{% extends '_base.html' %}
{% load static %}

{% block stylesheet %}
<!-- <link href="{% static 'css/video-js.min.css' %}" rel="stylesheet"> -->
<link href="https://vjs.zencdn.net/7.8.4/video-js.css" rel="stylesheet" />

<!-- If you'd like to support IE8 (for Video.js versions prior to v7) -->
<script src="https://vjs.zencdn.net/ie8/1.1.2/videojs-ie8.min.js"></script>
{% endblock %}


{% block content %}

        {% if stream.stream_status == "scheduled" or stream.stream_status == "requested" or stream.stream_status == "preparing" %}
        <div class="row mb-2">
            <div class="col-lg-2 col-md-2 col-xl-2">
            </div>
            <div class="col-lg-8">
                <div class="alert alert-info mt-3 mb-5">
                    <strong>{{stream.stream_name}}</strong> has not yet started. We will join you in as soon as it starts.
                </div>
            </div>
        </div>

        {% elif stream.stream_status == "stopped" or stream.stream_status == "destroyed" %}
        <div class="row mb-2">
            <div class="col-lg-2 col-md-2 col-xl-2">
            </div>
            <div class="col-lg-8">
                <div class="alert alert-warning mt-3 mb-5">
                    <strong>{{stream.stream_name}}</strong> has ended. Please contact the organizers for a recording.
                </div>
            </div>
        </div>
        {% else%}
            <div class="row mb-2">
                <div class="col-lg-8 col-md-8 col-sm-12">
                    <h5>{{stream.stream_name}}</h5>
                    <video id="player" class="video-js" controls preload="auto" data-setup="{}" style="display:none">
                        <p class="vjs-no-js">
                            To view this video please enable JavaScript, and consider upgrading to a
                            web browser that
                            <a rel="noopener noreferrer" href="https://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>
                        </p>
                    </video>
                    <span id="not_started" style="display:none">The session just started. The video will start playing anytime now.</span>
                </div>        

                <div class="col-lg-4 col-md-4 col-sm-12 mt-3">
                    <h5>Post your questions / comments here</h5>
                    <div class="input-group flex-nowrap">
                        <textarea class="form-control" placeholder="Questions / Comments " aria-label="Questions"
                            aria-describedby="addon-wrapping" id="question"></textarea>
                        <input type="hidden" name="comment" class="form-control" placeholder="Comments " aria-label="Comments"
                            aria-describedby="addon-wrapping">
                    </div>
                    <button class="btn btn-success btn-block mt-3" id="ask">Ask</button>
                    <div class="comment mt-2">
        
                        {% for comment in comments %}
                        <div id="questions_area">
                            <p><strong>{{comment.name}}</strong> says : <span class="lead mt-2"> {{comment.comment}}</span></p>
                        </div>
                        {% endfor %}
                    </div>
                </div>
            </div>
        {% endif %}



    {% endblock %}

    {% block javascript %}
    <script src="https://vjs.zencdn.net/7.8.4/video.js"></script>
    <script src="//cdn.dashjs.org/latest/dash.all.min.js"></script>
    <script src="{% static 'js/videojs-dash.min.js' %}"></script>
    {% if stream.stream_status == "ready" or stream.stream_status == "joined" or stream.stream_status == "running" %}
    <script>
        var url = "https://csmlivestreamassets.sgp1.digitaloceanspaces.com/47167aa5dd7d5bbc3f956db60fa74114/47167aa5dd7d5bbc3f956db60fa74114.mpd"
        // var url = "https://csmlivestreamassets.sgp1.digitaloceanspaces.com/{{stream.stream_id}}/{{stream.stream_id}}.mpd"
        // function video_start_tester() {          
        //     $.get(url,
        //         function (data, textStatus, jqXHR) {
        //         }).done(function(){
        //             startVideo()
        //         }).fail(function(){
        //             $("#player").hide()
        //             $("#not_started").show()
        //             setInterval(video_start_tester, 5000)
        //     });
        // }
        // function startVideo(){
            $("#player").show();
            $("#not_started").hide()
            var player = videojs('#player', {
            "liveui": true,
            "fluid": true,
            "responsive": true
        });
        player.src({
            src: url,
            type: 'application/dash+xml'
        });
        player.play()
        // }
        
        // video_start_tester()
    </script>
    <script>
        $("#ask").click(function () {
            var question = $("#question").val()
            if (question) {
                $.ajax({
                    type: "POST",
                    url: "{%url 'stream_ask_question'%}",
                    data: {
                        "csrfmiddlewaretoken": "{{csrf_token}}",
                        "question": question,
                        "stream_id": "{{stream.stream_id}}",
                        "name": "{{request.user|default_if_none:'Anonymous'}}",
                    },
                    success: function (response) {
                        alert("Question posted")
                        $("#question").val("")
                        $("#question").removeClass("is-invalid")
                    }
                });
            } else {
                $("#question").attr("placeholder", "No question asked")
                $("#question").addClass("is-invalid")
                setTimeout(function () {
                    $("#question").removeClass("is-invalid")
                    $("#question").attr("placeholder", "Questions / Comments")
                }, 5000)
            }
        })

        var sqid = null
        {% if comments %}
        sqid = {{ comments.last.id }};
        {% endif %}


        setInterval(function () {
            if (sqid) {
                $.get("{% url 'get_stream_questions' stream_id=stream.stream_id%}" + sqid + "/", {},
                    function (data, textStatus, jqXHR) {
                        append_new_questions(data)
                    }
                );
            } else {
                $.get("{% url 'get_stream_questions' stream_id=stream.stream_id%}", {},
                    function (data, textStatus, jqXHR) {
                        append_new_questions(data)
                    },
                );

            }
        },
            10000)

        function append_new_questions(data) {
            if (data.sqs.length > 0) {
                $.each(data.sqs, function (index, value) {
                    $("#questions_area").append('<p><strong>' + value[1] + '</strong> says : <span class="lead mt-2">' + value[2] + '</span></p>')
                })
                sqid = data.sqs[data.sqs.length - 1][0];
            }
        }
    </script>
    {% elif stream.stream_status == "scheduled" or stream.stream_status == "requested" or stream.stream_status == "preparing" %}
        <script>
             setTimeout(function() {
                    location.reload();
                }, 10000);
        </script>
    {% else%}

    {% endif %}
    {% endblock %}